%define plymouthdaemon_execdir /sbin
%define plymouthclient_execdir /bin
%define plymouth_libdir /%{_lib}
%define localstatedir /var
%define _libexecdir %{_prefix}/libexec
%define plymouthdaemon_execdir /sbin
%define plymouthclient_execdir /bin
%define plymouth_libdir /%{_lib}

%define _libexecdir %{_prefix}/libexec

%define build_gdm 0

%define lib_major 2
%define lib_name %mklibname %{name} %{lib_major}
%define lib_name_devel %mklibname %{name} -d

%define snapshot 0

%bcond_with uclibc

Summary: Graphical Boot Animation and Logger
Name: plymouth
Version: 0.8.3
Release: %mkrel 5
License: GPLv2+
Group: System/Kernel and hardware
Source0: http://freedesktop.org/software/plymouth/releases/%{name}-%{version}.tar.bz2
Source1: boot-duration
Source2: charge.plymouth
# Mandriva Patchset ------------------------------------------
Patch0: plymouth-0.8.3-tty-lock.patch
Patch1: plymouth-0.8.3-retain-vt.patch
Patch2: plymouth-0.8.3-details-not-available.patch
Patch3: plymouth-0.8.3-tty-OPOST-ONLCR.patch
Patch4: plymouth-0.8.3-smarter_init_detection.patch
Patch5: plymouth-0.8.3-change_socket_path.patch
Patch6: plymouth-0.8.3-change_socket_path-fix.patch
Patch7:	plymouth-0.7.2-add-missing-header.patch
Patch8: plymouth-0.8.3-library-link-order.patch
Patch9: plymouth-0.7.2-less-greedy-usr_lib-substitution.patch
Patch10: plymouth-0.8.3-initrd-absolute-path.patch
Patch11: plymouth-0.8.3-move-mkinitrd-functions-under-root-lib.patch
Patch12: plymouth-0.8.3-boot-server-don-t-print-error-when-client-goes-away.patch
Patch13: plymouth-0.8.3-terminal-unlock-tty-before-muc.patch
Patch14: plymouth-0.8.3-do_not_hang_on_wait_without_daemon.patch
#------------------------------------------------------------
URL: http://freedesktop.org/software/plymouth/releases
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: initscripts
Requires: mkinitrd
Requires: desktop-common-data
BuildRequires: gtk2-devel
Obsoletes: splashy
Provides: splashy

%description
Plymouth provides an attractive graphical boot animation in
place of the text messages that normally get shown.  Text
messages are instead redirected to a log file for viewing
after boot.

%package devel
Group: System/Kernel and hardware
Summary: Libraries and headers for writing Plymouth splash plugins
Group: Development/C
Requires: %{name} = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}
Provides: lib%{name}-devel = %{version}-%{release}

%description devel
This package contains the libply and libplybootsplash libraries
and headers needed to develop 3rd party splash plugins for Plymouth.


%if %{build_gdm}
%package gdm-hooks
Group: System/Kernel and hardware
Summary: Plymouth GDM integration
Requires: gdm 
Requires: %{name} = %{version}-%{release}

%description gdm-hooks
This package contains support files for integrating Plymouth with GDM
Namely, it adds hooks to show boot messages at the login screen in the
event start-up services fail.
%endif

%package theme-fade-in
Group: System/Kernel and hardware
Summary: Plymouth "Fade-In" theme
Requires(post): plymouth = %{version}-%{release}

%description theme-fade-in
This package contains the "Fade-In" boot splash theme for
Plymouth. It features a centered logo that fades in and out
while stars twinkle around the logo during system boot up.

%package theme-spinfinity
Group: System/Kernel and hardware
Summary: Plymouth "Spinfinity" theme
Requires(post): plymouth = %{version}-%{release}

%description theme-spinfinity
This package contains the "Spinfinity" boot splash theme for
Plymouth. It features a centered logo and animated spinner that
spins in the shape of an infinity sign.

%package theme-solar
Group: System/Kernel and hardware
Summary: Plymouth "Solar" theme
Requires(post): plymouth = %{version}-%{release}

%description theme-solar
This package contains the "Solar" boot splash theme for
Plymouth. It features a blue flamed sun with animated solar flares.

%package theme-charge
Group: System/Kernel and hardware
Summary: Plymouth "Charge" plugin
Requires(post): plymouth = %{version}-%{release}

%description theme-charge
This package contains the "charge" boot splash theme for
Plymouth. It features the shadowy hull of a logo charge up and
and finally burst into full form.

%package theme-glow
Group: System/Kernel and hardware
Summary: Plymouth "Glow" plugin
Requires(post): plymouth  = %{version}-%{release}

%description theme-glow
This package contains the "Glow" boot splash theme for Plymouth.

%package theme-script
Group: System/Kernel and hardware
Summary: Plymouth "Script" theme
Requires(post): plymouth = %{version}-%{release}

%description theme-script
This package contains the "Script" boot splash theme for
Plymouth. 


%prep
%setup -q
%patch0 -p1 -b .tty-lock
%patch1 -p1 -b .retain-vt
%patch2 -p1 -b .details-not-available
%patch3 -p1 -b .tty-OPOST-ONLCR
%patch4 -p1 -b .smarter_init_detection
%patch5 -p1 -b .change_socket_path
%patch6 -p1 -b .change_socket_path-fix
%patch7 -p1 -b .header~
%patch8 -p1 -b .link_order~
%patch9 -p1 -b .usrlib_subst~
%patch10 -p1 -b .abspath~
%patch11 -p1 -b .mkinitrd_lib~
%patch12 -p1 -b .could-not-write-bytes
%patch13 -p1 -b .tty_locked_settings
%patch14 -p1 -b .do_not_hang_on_wait
autoreconf --install --symlink

%build
export CONFIGURE_TOP=`pwd`
%if %{with uclibc}
mkdir -p uclibc
cd uclibc
%configure2_5x CC="%{uclibc_cc}" \
	CFLAGS="%{uclibc_cflags}" \
	LDFLAGS="%{ldflags} -lz" \
	--prefix=%{uclibc_root}%{_prefix} \
	--libdir="%{uclibc_root}%{_libdir}" \
	--bindir="%{uclibc_root}%{plymouthclient_execdir}" \
	--sbindir="%{uclibc_root}%{plymouthdaemon_execdir}" \
	--enable-tracing --disable-tests \
	--with-logo=%{_datadir}/icons/large/pclinuxos.png 		\
	--with-background-start-color-stop=0x0073B3			\
	--with-background-end-color-stop=0x00457E			\
	--with-background-color=0x3391cd				\
	--disable-gdm-transition					\
	--without-gdm-autostart-file					\
	--without-rhgb-compat-link					\
	--with-system-root-install 					\
	--with-boot-tty=tty7						\
	--with-shutdown-tty=tty1					\
	--with-release-file=/etc/pclinuxos-release

sed -e 's#viewer##g' -i src/Makefile
sed -e 's#label##g' -i src/plugins/controls/Makefile

%make
cd ..
%endif

mkdir -p system
cd system
%configure2_5x \
	--enable-tracing --disable-tests \
	--with-logo=%{_datadir}/icons/large/pclinuxos.png 		\
	--with-background-start-color-stop=0x0073B3			\
	--with-background-end-color-stop=0x00457E			\
	--with-background-color=0x3391cd				\
	--disable-gdm-transition					\
	--without-gdm-autostart-file					\
	--without-rhgb-compat-link					\
	--with-system-root-install 					\
	--with-boot-tty=tty7						\
	--with-shutdown-tty=tty1					\
	--with-release-file=/etc/pclinuxos-release

%make
cd ..

%install
rm -rf $RPM_BUILD_ROOT

%if %{with uclibc}
%makeinstall_std -C uclibc plymouthdaemondir=%{uclibc_root}%{plymouthdaemon_execdir} plymouthclientdir=%{uclibc_root}%{plymouthclient_execdir}
rm -rf %{buildroot}%{uclibc_root}{%{_includedir},%{_datadir},%{_libdir}/pkgconfig,%{_libexecdir},%{plymouthdaemon_execdir}/plymouth-set-default-theme}
%endif
%makeinstall_std -C system

find $RPM_BUILD_ROOT -name \*.a -delete -o -name \*.la -delete

# Temporary symlink until rc.sysinit is fixed
(cd $RPM_BUILD_ROOT%{_bindir}; ln -s ../../bin/plymouth)
touch $RPM_BUILD_ROOT%{_datadir}/plymouth/themes/default.plymouth

mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/plymouth
cp %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/plymouth/default-boot-duration
touch $RPM_BUILD_ROOT%{_localstatedir}/lib/plymouth/{boot,shutdown}-duration

# Add charge
mkdir -p $RPM_BUILD_ROOT%{_datadir}/plymouth/themes/charge
cp %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/plymouth/themes/charge
cp $RPM_BUILD_ROOT%{_datadir}/plymouth/themes/glow/{box,bullet,entry,lock}.png $RPM_BUILD_ROOT%{_datadir}/plymouth/themes/charge

%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/ldconfig
[ -f %{_localstatedir}/lib/plymouth/boot-duration ] || cp -f %{_datadir}/plymouth/default-boot-duration %{_localstatedir}/lib/plymouth/boot-duration

# Dont switch themes or it will mess up community editions

#/usr/sbin/plymouth-set-default-theme PCLinuxOS
#/usr/share/bootsplash/scripts/switch-themes PCLinuxOS 


%files
%defattr(-, root, root)
%doc AUTHORS NEWS README
%config(noreplace) %{_sysconfdir}/plymouth
%dir %{_datadir}/plymouth
%dir %{_datadir}/plymouth/themes
%{_datadir}/plymouth/default-boot-duration
%dir %{_localstatedir}/lib/plymouth
%{plymouthdaemon_execdir}/plymouthd
%{plymouthclient_execdir}/plymouth
%{_bindir}/plymouth
%{_libdir}/plymouth/details.so
%{_libdir}/plymouth/text.so
%ghost %{_datadir}/plymouth/themes/default.plymouth
%{_datadir}/plymouth/themes/details
%{_datadir}/plymouth/themes/text
%{_localstatedir}/run/plymouth
%{_localstatedir}/spool/plymouth
%ghost %{_localstatedir}/lib/plymouth/shutdown-duration
%ghost %{_localstatedir}/lib/plymouth/boot-duration
%{plymouth_libdir}/libply.so.*
%dir %{_libdir}/plymouth
%{_libdir}/plymouth/label.so
%{_libdir}/plymouth/fade-throbber.so
%{_libdir}/plymouth/throbgress.so
%{_libdir}/plymouth/script.so
%{_libdir}/plymouth/space-flares.so
%{_libdir}/plymouth/two-step.so
%{_sbindir}/plymouth-set-default-theme
%{_libexecdir}/plymouth
%{_bindir}/plymouth-log-viewer
%dir %{_libdir}/plymouth/renderers
%{_libdir}/plymouth/renderers/drm*
%{_libdir}/plymouth/renderers/frame-buffer*
%{_libdir}/plymouth/renderers/x11*
%{_datadir}/plymouth/plymouthd.defaults
%{_mandir}/man8/

/%{_lib}/libply-splash-core.so.2
/%{_lib}/libply-splash-core.so.2.0.0
%{_libdir}/libply-boot-client.so.2
%{_libdir}/libply-boot-client.so.2.0.0
%{_libdir}/libply-splash-graphics.so.2
%{_libdir}/libply-splash-graphics.so.2.0.0

%files devel
%defattr(-, root, root)
%{plymouth_libdir}/libply.so
%{_includedir}/plymouth-1
%{_libdir}/pkgconfig/*.pc

/%{_lib}/libply-splash-core.so
%{_libdir}/libply-boot-client.so
%{_libdir}/libply-splash-graphics.so

%if %{build_gdm}
%files gdm-hooks
%defattr(-, root, root)
%{_datadir}/gdm/autostart/LoginWindow/plymouth-log-viewer.desktop
%endif

#--------------------------------------------------------------------
%files theme-fade-in
%defattr(-, root, root)
%{_datadir}/plymouth/themes/fade-in

%post theme-fade-in
/usr/sbin/plymouth-set-default-theme fade-in
/usr/share/bootsplash/scripts/switch-themes fade-in 

%postun theme-fade-in
/usr/sbin/plymouth-set-default-theme text
/usr/share/bootsplash/scripts/switch-themes text 

#--------------------------------------------------------------------
%files theme-spinfinity
%defattr(-, root, root)
%{_datadir}/plymouth/themes/spinfinity

%post theme-spinfinity
/usr/sbin/plymouth-set-default-theme spinfinity
/usr/share/bootsplash/scripts/switch-themes spinfinity

%postun theme-spinfinity
/usr/sbin/plymouth-set-default-theme text
/usr/share/bootsplash/scripts/switch-themes text 

#--------------------------------------------------------------------
%files theme-solar
%defattr(-, root, root)
%{_datadir}/plymouth/themes/solar

%post theme-solar
/usr/sbin/plymouth-set-default-theme solar
/usr/share/bootsplash/scripts/switch-themes solar

%postun theme-solar
/usr/sbin/plymouth-set-default-theme text
/usr/share/bootsplash/scripts/switch-themes text 

#--------------------------------------------------------------------
%files theme-charge
%defattr(-, root, root)
%{_datadir}/plymouth/themes/charge

%post theme-charge
/usr/sbin/plymouth-set-default-theme charge
/usr/share/bootsplash/scripts/switch-themes charge

%postun theme-charge
/usr/sbin/plymouth-set-default-theme text
/usr/share/bootsplash/scripts/switch-themes text 

#--------------------------------------------------------------------
%files theme-glow
%defattr(-, root, root)
%{_datadir}/plymouth/themes/glow

%post theme-glow
/usr/sbin/plymouth-set-default-theme glow
/usr/share/bootsplash/scripts/switch-themes glow

%postun theme-glow
/usr/sbin/plymouth-set-default-theme text
/usr/share/bootsplash/scripts/switch-themes text

#--------------------------------------------------------------------
%files theme-script
%defattr(-, root, root)
%{_datadir}/plymouth/themes/script

%post theme-script
/usr/sbin/plymouth-set-default-theme script
/usr/share/bootsplash/scripts/switch-themes script

%postun theme-script
/usr/sbin/plymouth-set-default-theme text
/usr/share/bootsplash/scripts/switch-themes text

%changelog
* Sun Apr  1 2012 Neal <nealbrks0 at gmail dot com> 0.8.3-5pclos2012
- process

* Sun Apr  1 2012 AS <as.pclos at gmail.com> 0.8.3-5pclos2012
- fixes to specfile

* Sat Mar 31 2012 Neal <nealbrks0 at gmail.com> 0.8.3-4pclos2012
- process

* Sat Mar 31 2012 AS <as.pclos at gmail.com> 0.8.3-4pclos2012
- fix error while running mkinitrd on 32 bit, (icon mandriva.png)
- build on both 32 and 64 bit systems

* Mon Aug 15 2011 Texstar <texstar at gmail.com> 0.8.3-3pclos2011
- fix specfile

* Mon Aug 01 2011 Texstar <texstar at gmail.com> 0.8.3-2pclos2011
- update patches

* Mon May 31 2010 Texstar <texstar at gmail.com> 0.8.3-1pclos2010
- sync to mdv to fix VT switch issue when stopping plymouth

* Fri Apr 09 2010 Texstar <texstar at gmail.com> 0.7.2-2pclos2010
- sync to mdv to see if fixes mylivecd boot graphics issue

* Thu Jan 14 2010 Texstar <texstar at gmail.com> 0.7.2-1pclos2010
- import into pclos

